{{

 Lorenz 3D fractal map function

}}
CON
   
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ

  fM: "Float32Full"
  lcd : "Nokia6100"
    
var

   long x,y,z,oldx,oldy,oldz,xn,yn                    
      
PUB main

  lcd.start(4, 5, 6, 7, lcd#EPSON)
  lcd.background(lcd#BLACK)  
  lcd.color(lcd#WHITE)
  lcd.clear

  fM.start

   x := 0.5                                  
   y := 0.5
   z := fM.FNeg(1.0)

   repeat

      oldx := x
      oldy := y
      oldz := z
                                     
      x := fM.FSub(fM.FMul(oldx,oldy),oldz) ' x = x*y-z
      y := oldx                             ' y = x
      z := oldy                             ' z = y
      
      xn := fM.FTrunc(fM.FMul(x,10000.0))
      yn := fM.FTrunc(fM.FMul(y,10000.0))
      
      lcd.plot(65+(xn/220),65+(yn/220))
             
     